using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Data;
using System.Data.SqlClient;
using System.Configuration;

public partial class CS : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!this.IsPostBack)
        {
            this.BindGrid();
        }
    }

    private void BindGrid()
    {
        string conString = ConfigurationManager.ConnectionStrings["constr"].ConnectionString;
        using (SqlConnection con = new SqlConnection(conString))
        {
            string query = "SELECT CustomerID, City, PostalCode FROM Customers";
            using (SqlDataAdapter sda = new SqlDataAdapter(query, con))
            {
                using (DataTable dt = new DataTable())
                {
                    sda.Fill(dt);
                    gvCustomers.DataSource = dt;
                    gvCustomers.DataBind();
                }
            }
        }
    }

    protected void OnPaging(object sender, GridViewPageEventArgs e)
    {
        this.GetSelectedRecord();
        gvCustomers.PageIndex = e.NewPageIndex;
        this.BindGrid();
        this.SetSelectedRecord();
    }

    private void GetSelectedRecord()
    {
        GridViewRow selectedRow = (from GridViewRow row in gvCustomers.Rows
                                   where (row.FindControl("rbCustomer") as RadioButton).Checked == true
                                   select row).FirstOrDefault();
        if (selectedRow != null)
        {
            ViewState["SelctedCustomer"] = gvCustomers.DataKeys[selectedRow.RowIndex].Values[0];
        }
    }

    private void SetSelectedRecord()
    {
        if (ViewState["SelctedCustomer"] != null)
        {
            RadioButton rbCustomer = (from GridViewRow row in gvCustomers.Rows
                                      where gvCustomers.DataKeys[row.RowIndex].Values[0].ToString() == ViewState["SelctedCustomer"].ToString()
                                      select (row.FindControl("rbCustomer") as RadioButton)).FirstOrDefault();
            if (rbCustomer != null)
            {
                rbCustomer.Checked = true;
            }
        }
    }
}
